"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const qwik = require("@builder.io/qwik");
const jsxRuntime = require("@builder.io/qwik/jsx-runtime");
const target = require("../../constants/target.qwik.cjs");
const getBlockComponentOptions = require("../../functions/get-block-component-options.qwik.cjs");
const getProcessedBlock = require("../../functions/get-processed-block.qwik.cjs");
const animator = require("./animator.qwik.cjs");
const block_helpers = require("./block.helpers.qwik.cjs");
const blockStyles = require("./components/block-styles.qwik.cjs");
const blockWrapper = require("./components/block-wrapper.qwik.cjs");
const componentRef = require("./components/component-ref/component-ref.qwik.cjs");
const repeatedBlock = require("./components/repeated-block.qwik.cjs");
const Block = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  var _a;
  qwik._jsxBranch();
  qwik.useStore({
    _processedBlock: {
      value: null,
      update: false
    }
  });
  const repeatItem = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2] = qwik.useLexicalScope();
    return block_helpers.getRepeatItemData({
      block: props2.block,
      context: props2.context
    });
  }, "Block_component_repeatItem_useComputed_j31Y3wFqSCM", [
    props
  ]));
  const processedBlock = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a2;
    const [props2] = qwik.useLexicalScope();
    const blockToUse = ((_a2 = props2.block.repeat) == null ? void 0 : _a2.collection) ? props2.block : getProcessedBlock.getProcessedBlock({
      block: props2.block,
      localState: props2.context.localState,
      rootState: props2.context.rootState,
      rootSetState: props2.context.rootSetState,
      context: props2.context.context
    });
    return blockToUse;
  }, "Block_component_processedBlock_useComputed_ESKw0l5FcBc", [
    props
  ]));
  const blockComponent = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [processedBlock2, props2] = qwik.useLexicalScope();
    return block_helpers.getComponent({
      block: processedBlock2.value,
      registeredComponents: props2.registeredComponents,
      model: props2.context.model
    });
  }, "Block_component_blockComponent_useComputed_83sGy9Xlsi0", [
    processedBlock,
    props
  ]));
  const Tag = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a2;
    const [processedBlock2, props2] = qwik.useLexicalScope();
    const shouldUseLink = props2.block.tagName === "a" || ((_a2 = processedBlock2.value.properties) == null ? void 0 : _a2.href) || processedBlock2.value.href;
    if (shouldUseLink)
      return props2.linkComponent || "a";
    return props2.block.tagName || "div";
  }, "Block_component_Tag_useComputed_eQnDgbcBW2A", [
    processedBlock,
    props
  ]));
  const canShowBlock = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a2, _b;
    const [processedBlock2, props2, repeatItem2] = qwik.useLexicalScope();
    if ((_a2 = props2.block.repeat) == null ? void 0 : _a2.collection) {
      if ((_b = repeatItem2.value) == null ? void 0 : _b.length)
        return true;
      return false;
    }
    const shouldHide = "hide" in processedBlock2.value ? processedBlock2.value.hide : false;
    const shouldShow = "show" in processedBlock2.value ? processedBlock2.value.show : true;
    return shouldShow && !shouldHide;
  }, "Block_component_canShowBlock_useComputed_NJEFz8ICF08", [
    processedBlock,
    props,
    repeatItem
  ]));
  const childrenWithoutParentComponent = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a2;
    const [blockComponent2, processedBlock2, repeatItem2] = qwik.useLexicalScope();
    const shouldRenderChildrenOutsideRef = !((_a2 = blockComponent2.value) == null ? void 0 : _a2.component) && !repeatItem2.value;
    return shouldRenderChildrenOutsideRef ? processedBlock2.value.children ?? [] : [];
  }, "Block_component_childrenWithoutParentComponent_useComputed_0WENYGElWnc", [
    blockComponent,
    processedBlock,
    repeatItem
  ]));
  const componentRefProps = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a2, _b, _c;
    const [blockComponent2, processedBlock2, props2] = qwik.useLexicalScope();
    return {
      blockChildren: processedBlock2.value.children ?? [],
      componentRef: (_a2 = blockComponent2.value) == null ? void 0 : _a2.component,
      componentOptions: {
        ...getBlockComponentOptions.getBlockComponentOptions(processedBlock2.value, props2.context),
        ...block_helpers.provideBuilderBlock(blockComponent2.value, processedBlock2.value),
        ...block_helpers.provideBuilderContext(blockComponent2.value, props2.context),
        ...block_helpers.provideLinkComponent(blockComponent2.value, props2.linkComponent),
        ...block_helpers.provideRegisteredComponents(blockComponent2.value, props2.registeredComponents, props2.context.model)
      },
      context: props2.context,
      linkComponent: props2.linkComponent,
      registeredComponents: props2.registeredComponents,
      builderBlock: processedBlock2.value,
      includeBlockProps: ((_b = blockComponent2.value) == null ? void 0 : _b.noWrap) === true,
      isInteractive: !(((_c = blockComponent2.value) == null ? void 0 : _c.isRSC) && target.TARGET === "rsc")
    };
  }, "Block_component_componentRefProps_useComputed_Ikbl8VO04ho", [
    blockComponent,
    processedBlock,
    props
  ]));
  qwik.useVisibleTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [processedBlock2] = qwik.useLexicalScope();
    const blockId = processedBlock2.value.id;
    const animations = processedBlock2.value.animations;
    if (animations && blockId)
      animator.bindAnimations(animations.map((animation) => ({
        ...animation,
        elementId: blockId
      })));
  }, "Block_component_useVisibleTask_hrTYvqw0Tbs", [
    processedBlock
  ]));
  qwik.useTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(({ track }) => {
  }, "Block_component_useTask_Xb7FQvPjBMo"));
  return /* @__PURE__ */ qwik._jsxC(jsxRuntime.Fragment, {
    children: canShowBlock.value ? /* @__PURE__ */ qwik._jsxC(jsxRuntime.Fragment, {
      children: [
        /* @__PURE__ */ qwik._jsxC(blockStyles.BlockStyles, {
          get block() {
            return processedBlock.value;
          },
          get context() {
            return props.context;
          },
          [qwik._IMMUTABLE]: {
            block: qwik._fnSignal((p0) => p0.value, [
              processedBlock
            ], "p0.value"),
            context: qwik._fnSignal((p0) => p0.context, [
              props
            ], "p0.context")
          }
        }, 3, "jN_0"),
        !((_a = blockComponent.value) == null ? void 0 : _a.noWrap) ? !repeatItem.value ? /* @__PURE__ */ qwik._jsxC(blockWrapper.BlockWrapper, {
          get Wrapper() {
            return Tag.value;
          },
          get block() {
            return processedBlock.value;
          },
          get context() {
            return props.context;
          },
          children: [
            /* @__PURE__ */ qwik._jsxC(componentRef.ComponentRef, {
              get componentRef() {
                return componentRefProps.value.componentRef;
              },
              get componentOptions() {
                return componentRefProps.value.componentOptions;
              },
              get blockChildren() {
                return componentRefProps.value.blockChildren;
              },
              get context() {
                return componentRefProps.value.context;
              },
              get registeredComponents() {
                return componentRefProps.value.registeredComponents;
              },
              get linkComponent() {
                return componentRefProps.value.linkComponent;
              },
              get builderBlock() {
                return componentRefProps.value.builderBlock;
              },
              get includeBlockProps() {
                return componentRefProps.value.includeBlockProps;
              },
              get isInteractive() {
                return componentRefProps.value.isInteractive;
              },
              [qwik._IMMUTABLE]: {
                blockChildren: qwik._fnSignal((p0) => p0.value.blockChildren, [
                  componentRefProps
                ], "p0.value.blockChildren"),
                builderBlock: qwik._fnSignal((p0) => p0.value.builderBlock, [
                  componentRefProps
                ], "p0.value.builderBlock"),
                componentOptions: qwik._fnSignal((p0) => p0.value.componentOptions, [
                  componentRefProps
                ], "p0.value.componentOptions"),
                componentRef: qwik._fnSignal((p0) => p0.value.componentRef, [
                  componentRefProps
                ], "p0.value.componentRef"),
                context: qwik._fnSignal((p0) => p0.value.context, [
                  componentRefProps
                ], "p0.value.context"),
                includeBlockProps: qwik._fnSignal((p0) => p0.value.includeBlockProps, [
                  componentRefProps
                ], "p0.value.includeBlockProps"),
                isInteractive: qwik._fnSignal((p0) => p0.value.isInteractive, [
                  componentRefProps
                ], "p0.value.isInteractive"),
                linkComponent: qwik._fnSignal((p0) => p0.value.linkComponent, [
                  componentRefProps
                ], "p0.value.linkComponent"),
                registeredComponents: qwik._fnSignal((p0) => p0.value.registeredComponents, [
                  componentRefProps
                ], "p0.value.registeredComponents")
              }
            }, 3, "jN_1"),
            (childrenWithoutParentComponent.value || []).map((child) => {
              return /* @__PURE__ */ qwik._jsxC(Block, {
                block: child,
                get registeredComponents() {
                  return props.registeredComponents;
                },
                get linkComponent() {
                  return props.linkComponent;
                },
                get context() {
                  return props.context;
                },
                [qwik._IMMUTABLE]: {
                  context: qwik._fnSignal((p0) => p0.context, [
                    props
                  ], "p0.context"),
                  linkComponent: qwik._fnSignal((p0) => p0.linkComponent, [
                    props
                  ], "p0.linkComponent"),
                  registeredComponents: qwik._fnSignal((p0) => p0.registeredComponents, [
                    props
                  ], "p0.registeredComponents")
                }
              }, 3, child.id);
            })
          ],
          [qwik._IMMUTABLE]: {
            Wrapper: qwik._fnSignal((p0) => p0.value, [
              Tag
            ], "p0.value"),
            block: qwik._fnSignal((p0) => p0.value, [
              processedBlock
            ], "p0.value"),
            context: qwik._fnSignal((p0) => p0.context, [
              props
            ], "p0.context")
          }
        }, 1, "jN_2") : (repeatItem.value || []).map((data, index) => {
          return /* @__PURE__ */ qwik._jsxC(repeatedBlock.RepeatedBlock, {
            get repeatContext() {
              return data.context;
            },
            get block() {
              return data.block;
            },
            get registeredComponents() {
              return props.registeredComponents;
            },
            get linkComponent() {
              return props.linkComponent;
            },
            [qwik._IMMUTABLE]: {
              block: qwik._wrapProp(data, "block"),
              linkComponent: qwik._fnSignal((p0) => p0.linkComponent, [
                props
              ], "p0.linkComponent"),
              registeredComponents: qwik._fnSignal((p0) => p0.registeredComponents, [
                props
              ], "p0.registeredComponents"),
              repeatContext: qwik._wrapProp(data, "context")
            }
          }, 3, index);
        }) : !repeatItem.value ? /* @__PURE__ */ qwik._jsxC(componentRef.ComponentRef, {
          get componentRef() {
            return componentRefProps.value.componentRef;
          },
          get componentOptions() {
            return componentRefProps.value.componentOptions;
          },
          get blockChildren() {
            return componentRefProps.value.blockChildren;
          },
          get context() {
            return componentRefProps.value.context;
          },
          get registeredComponents() {
            return componentRefProps.value.registeredComponents;
          },
          get linkComponent() {
            return componentRefProps.value.linkComponent;
          },
          get builderBlock() {
            return componentRefProps.value.builderBlock;
          },
          get includeBlockProps() {
            return componentRefProps.value.includeBlockProps;
          },
          get isInteractive() {
            return componentRefProps.value.isInteractive;
          },
          [qwik._IMMUTABLE]: {
            blockChildren: qwik._fnSignal((p0) => p0.value.blockChildren, [
              componentRefProps
            ], "p0.value.blockChildren"),
            builderBlock: qwik._fnSignal((p0) => p0.value.builderBlock, [
              componentRefProps
            ], "p0.value.builderBlock"),
            componentOptions: qwik._fnSignal((p0) => p0.value.componentOptions, [
              componentRefProps
            ], "p0.value.componentOptions"),
            componentRef: qwik._fnSignal((p0) => p0.value.componentRef, [
              componentRefProps
            ], "p0.value.componentRef"),
            context: qwik._fnSignal((p0) => p0.value.context, [
              componentRefProps
            ], "p0.value.context"),
            includeBlockProps: qwik._fnSignal((p0) => p0.value.includeBlockProps, [
              componentRefProps
            ], "p0.value.includeBlockProps"),
            isInteractive: qwik._fnSignal((p0) => p0.value.isInteractive, [
              componentRefProps
            ], "p0.value.isInteractive"),
            linkComponent: qwik._fnSignal((p0) => p0.value.linkComponent, [
              componentRefProps
            ], "p0.value.linkComponent"),
            registeredComponents: qwik._fnSignal((p0) => p0.value.registeredComponents, [
              componentRefProps
            ], "p0.value.registeredComponents")
          }
        }, 3, "jN_3") : (repeatItem.value || []).map((data, index) => {
          return /* @__PURE__ */ qwik._jsxC(repeatedBlock.RepeatedBlock, {
            get repeatContext() {
              return data.context;
            },
            get block() {
              return data.block;
            },
            get registeredComponents() {
              return props.registeredComponents;
            },
            get linkComponent() {
              return props.linkComponent;
            },
            [qwik._IMMUTABLE]: {
              block: qwik._wrapProp(data, "block"),
              linkComponent: qwik._fnSignal((p0) => p0.linkComponent, [
                props
              ], "p0.linkComponent"),
              registeredComponents: qwik._fnSignal((p0) => p0.registeredComponents, [
                props
              ], "p0.registeredComponents"),
              repeatContext: qwik._wrapProp(data, "context")
            }
          }, 3, index);
        })
      ]
    }, 1, "jN_4") : null
  }, 1, "jN_5");
}, "Block_component_nnPv0RY0U0k"));
exports.Block = Block;
exports.default = Block;
