"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const qwik = require("@builder.io/qwik");
const isEditing = require("../../functions/is-editing.qwik.cjs");
const onClick = function onClick2(props, state, className, dataPath, blocksWrapperRef) {
  var _a, _b;
  if (isEditing.isEditing() && !((_a = props.blocks) == null ? void 0 : _a.length))
    (_b = window.parent) == null ? void 0 : _b.postMessage({
      type: "builder.clickEmptyBlocks",
      data: {
        parentElementId: props.parent,
        dataPath: dataPath.value
      }
    }, "*");
};
const onMouseEnter = function onMouseEnter2(props, state, className, dataPath, blocksWrapperRef) {
  var _a, _b;
  if (isEditing.isEditing() && !((_a = props.blocks) == null ? void 0 : _a.length))
    (_b = window.parent) == null ? void 0 : _b.postMessage({
      type: "builder.hoverEmptyBlocks",
      data: {
        parentElementId: props.parent,
        dataPath: dataPath.value
      }
    }, "*");
};
const BlocksWrapper = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  qwik.useStylesScopedQrl(/* @__PURE__ */ qwik.inlinedQrl(STYLES, "BlocksWrapper_component_useStylesScoped_Kj0S9AOXQ0o"));
  const className = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a;
    const [props2] = qwik.useLexicalScope();
    return [
      "builder-blocks",
      !((_a = props2.blocks) == null ? void 0 : _a.length) ? "no-blocks" : "",
      props2.classNameProp
    ].filter(Boolean).join(" ");
  }, "BlocksWrapper_component_className_useComputed_J5SSSH2Xf08", [
    props
  ]));
  const dataPath = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2] = qwik.useLexicalScope();
    if (!props2.path)
      return void 0;
    const thisPrefix = "this.";
    const pathPrefix = "component.options.";
    return props2.path.startsWith(thisPrefix) ? props2.path.replace(thisPrefix, "") : props2.path.startsWith(pathPrefix) ? props2.path : `${pathPrefix}${props2.path || ""}`;
  }, "BlocksWrapper_component_dataPath_useComputed_csBNeJbWH7k", [
    props
  ]));
  const blocksWrapperRef = qwik.useSignal();
  const state = qwik.useStore({
    shouldUpdate: false
  });
  qwik.useVisibleTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
  }, "BlocksWrapper_component_useVisibleTask_Z6vLhpCjVno"));
  qwik.useTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(({ track }) => {
    const [props2] = qwik.useLexicalScope();
    track(() => props2.blocks);
  }, "BlocksWrapper_component_useTask_MRcgThpiGRc", [
    props
  ]));
  return /* @__PURE__ */ qwik._jsxC(props.BlocksWrapper, {
    ref: blocksWrapperRef,
    get class() {
      return className.value + " props-blocks-wrapper-BlocksWrapper";
    },
    get "builder-path"() {
      return dataPath.value;
    },
    get "builder-parent-id"() {
      return props.parent;
    },
    get style() {
      return props.styleProp;
    },
    onClick$: /* @__PURE__ */ qwik.inlinedQrl((event) => {
      const [blocksWrapperRef2, className2, dataPath2, props2, state2] = qwik.useLexicalScope();
      return onClick(props2, state2, className2, dataPath2);
    }, "BlocksWrapper_component_onClick_ufezvOupQrM", [
      blocksWrapperRef,
      className,
      dataPath,
      props,
      state
    ]),
    onKeyPress$: /* @__PURE__ */ qwik.inlinedQrl((event) => {
      const [blocksWrapperRef2, className2, dataPath2, props2, state2] = qwik.useLexicalScope();
      return onClick(props2, state2, className2, dataPath2);
    }, "BlocksWrapper_component_onKeyPress_9bz8vCQc3kg", [
      blocksWrapperRef,
      className,
      dataPath,
      props,
      state
    ]),
    onMouseEnter$: /* @__PURE__ */ qwik.inlinedQrl((event) => {
      const [blocksWrapperRef2, className2, dataPath2, props2, state2] = qwik.useLexicalScope();
      return onMouseEnter(props2, state2, className2, dataPath2);
    }, "BlocksWrapper_component_onMouseEnter_j4FJjnLtraQ", [
      blocksWrapperRef,
      className,
      dataPath,
      props,
      state
    ]),
    ...props.BlocksWrapperProps,
    children: /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "3u_0"),
    [qwik._IMMUTABLE]: {
      "builder-parent-id": qwik._fnSignal((p0) => p0.parent, [
        props
      ], "p0.parent"),
      "builder-path": qwik._fnSignal((p0) => p0.value, [
        dataPath
      ], "p0.value"),
      class: qwik._fnSignal((p0) => p0.value + " props-blocks-wrapper-BlocksWrapper", [
        className
      ], 'p0.value+" props-blocks-wrapper-BlocksWrapper"'),
      ref: qwik._IMMUTABLE,
      style: qwik._fnSignal((p0) => p0.styleProp, [
        props
      ], "p0.styleProp")
    }
  }, 0, "3u_1");
}, "BlocksWrapper_component_45hR0o6abzg"));
const STYLES = `
.props-blocks-wrapper-BlocksWrapper {
  display: flex;
  flex-direction: column;
  align-items: stretch;
}
`;
exports.BlocksWrapper = BlocksWrapper;
exports.STYLES = STYLES;
exports.default = BlocksWrapper;
exports.onClick = onClick;
exports.onMouseEnter = onMouseEnter;
