"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const qwik = require("@builder.io/qwik");
const builderRegisteredComponents = require("../../constants/builder-registered-components.qwik.cjs");
const components_context = require("../../context/components.context.qwik.cjs");
const evaluate = require("../../functions/evaluate/evaluate.qwik.cjs");
const registerComponent = require("../../functions/register-component.qwik.cjs");
const logger = require("../../helpers/logger.qwik.cjs");
const blocks = require("../blocks/blocks.qwik.cjs");
const helpers = require("../content-variants/helpers.qwik.cjs");
const inlinedScript = require("../inlined-script.qwik.cjs");
const enableEditor = require("./components/enable-editor.qwik.cjs");
const styles = require("./components/styles.qwik.cjs");
const content_helpers = require("./content.helpers.qwik.cjs");
const ContentComponent = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  var _a, _b;
  qwik._jsxBranch();
  const state = qwik.useStore({
    builderContextSignal: {
      content: content_helpers.getContentInitialValue({
        content: JSON.parse(JSON.stringify(props.content || {})),
        data: props.data
      }),
      localState: void 0,
      rootState: content_helpers.getRootStateInitialValue({
        content: props.content,
        data: props.data,
        locale: props.locale
      }),
      rootSetState: void 0,
      context: props.context || {},
      canTrack: props.canTrack,
      apiKey: props.apiKey,
      apiVersion: props.apiVersion,
      componentInfos: [
        ...builderRegisteredComponents.getDefaultRegisteredComponents(),
        ...props.customComponents || []
      ].reduce((acc, { component: _, ...info }) => ({
        ...acc,
        [info.name]: registerComponent.serializeIncludingFunctions(info)
      }), {}),
      inheritedStyles: {},
      BlocksWrapper: props.blocksWrapper || "div",
      BlocksWrapperProps: props.blocksWrapperProps || {},
      nonce: props.nonce || "",
      model: props.model
    },
    registeredComponents: [
      ...builderRegisteredComponents.getDefaultRegisteredComponents(),
      ...props.customComponents || []
    ].reduce((acc, { component, ...info }) => ({
      ...acc,
      [info.name]: {
        component,
        ...registerComponent.serializeIncludingFunctions(info)
      }
    }), {}),
    scriptStr: helpers.getUpdateVariantVisibilityScript({
      // eslint-disable-next-line @typescript-eslint/no-non-null-assertion, @typescript-eslint/no-non-null-asserted-optional-chain
      variationId: (_a = props.content) == null ? void 0 : _a.testVariationId,
      // eslint-disable-next-line @typescript-eslint/no-non-null-assertion, @typescript-eslint/no-non-null-asserted-optional-chain
      contentId: (_b = props.content) == null ? void 0 : _b.id
    })
  }, {
    deep: true
  });
  qwik.useContextProvider(components_context, qwik.useStore({
    registeredComponents: state.registeredComponents
  }));
  qwik.useTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a2, _b2;
    const [props2, state2] = qwik.useLexicalScope();
    if (!props2.apiKey)
      logger.logger.error("No API key provided to `Content` component. This can cause issues. Please provide an API key using the `apiKey` prop.");
    const jsCode = (_b2 = (_a2 = state2.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.jsCode;
    if (jsCode)
      evaluate.evaluate({
        code: jsCode,
        context: props2.context || {},
        localState: void 0,
        rootState: state2.builderContextSignal.rootState,
        rootSetState: (newState) => {
          var _a3, _b3;
          (_b3 = (_a3 = state2.builderContextSignal).rootSetState) == null ? void 0 : _b3.call(_a3, newState);
        },
        isExpression: false
      });
  }, "ContentComponent_component_useTask_DB1dCCWPU8M", [
    props,
    state
  ]));
  return /* @__PURE__ */ qwik._jsxC(enableEditor.EnableEditor, {
    get apiHost() {
      return props.apiHost;
    },
    get nonce() {
      return props.nonce;
    },
    get content() {
      return props.content;
    },
    get data() {
      return props.data;
    },
    get model() {
      return props.model;
    },
    get context() {
      return props.context;
    },
    get apiKey() {
      return props.apiKey;
    },
    get canTrack() {
      return props.canTrack;
    },
    get locale() {
      return props.locale;
    },
    get enrich() {
      return props.enrich;
    },
    get showContent() {
      return props.showContent;
    },
    get builderContextSignal() {
      return state.builderContextSignal;
    },
    get contentWrapper() {
      return props.contentWrapper;
    },
    get contentWrapperProps() {
      return props.contentWrapperProps;
    },
    get trustedHosts() {
      return props.trustedHosts;
    },
    get isNestedRender() {
      return props.isNestedRender;
    },
    children: [
      props.isSsrAbTest ? /* @__PURE__ */ qwik._jsxC(inlinedScript.InlinedScript, {
        id: "builderio-variant-visibility",
        get scriptStr() {
          return state.scriptStr;
        },
        get nonce() {
          return props.nonce || "";
        },
        [qwik._IMMUTABLE]: {
          id: qwik._IMMUTABLE,
          nonce: qwik._fnSignal((p0) => p0.nonce || "", [
            props
          ], 'p0.nonce||""'),
          scriptStr: qwik._fnSignal((p0) => p0.scriptStr, [
            state
          ], "p0.scriptStr")
        }
      }, 3, "LQ_0") : null,
      /* @__PURE__ */ qwik._jsxC(styles.ContentStyles, {
        get nonce() {
          return props.nonce || "";
        },
        get isNestedRender() {
          return props.isNestedRender;
        },
        get contentId() {
          var _a2;
          return (_a2 = state.builderContextSignal.content) == null ? void 0 : _a2.id;
        },
        get cssCode() {
          var _a2, _b2;
          return (_b2 = (_a2 = state.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.cssCode;
        },
        get customFonts() {
          var _a2, _b2;
          return (_b2 = (_a2 = state.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.customFonts;
        },
        [qwik._IMMUTABLE]: {
          contentId: qwik._fnSignal((p0) => {
            var _a2;
            return (_a2 = p0.builderContextSignal.content) == null ? void 0 : _a2.id;
          }, [
            state
          ], "p0.builderContextSignal.content?.id"),
          cssCode: qwik._fnSignal((p0) => {
            var _a2, _b2;
            return (_b2 = (_a2 = p0.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.cssCode;
          }, [
            state
          ], "p0.builderContextSignal.content?.data?.cssCode"),
          customFonts: qwik._fnSignal((p0) => {
            var _a2, _b2;
            return (_b2 = (_a2 = p0.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.customFonts;
          }, [
            state
          ], "p0.builderContextSignal.content?.data?.customFonts"),
          isNestedRender: qwik._fnSignal((p0) => p0.isNestedRender, [
            props
          ], "p0.isNestedRender"),
          nonce: qwik._fnSignal((p0) => p0.nonce || "", [
            props
          ], 'p0.nonce||""')
        }
      }, 3, "LQ_1"),
      /* @__PURE__ */ qwik._jsxC(blocks.Blocks, {
        get blocks() {
          var _a2, _b2;
          return (_b2 = (_a2 = state.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.blocks;
        },
        get context() {
          return state.builderContextSignal;
        },
        get registeredComponents() {
          return state.registeredComponents;
        },
        get linkComponent() {
          return props.linkComponent;
        },
        [qwik._IMMUTABLE]: {
          blocks: qwik._fnSignal((p0) => {
            var _a2, _b2;
            return (_b2 = (_a2 = p0.builderContextSignal.content) == null ? void 0 : _a2.data) == null ? void 0 : _b2.blocks;
          }, [
            state
          ], "p0.builderContextSignal.content?.data?.blocks"),
          context: qwik._fnSignal((p0) => p0.builderContextSignal, [
            state
          ], "p0.builderContextSignal"),
          linkComponent: qwik._fnSignal((p0) => p0.linkComponent, [
            props
          ], "p0.linkComponent"),
          registeredComponents: qwik._fnSignal((p0) => p0.registeredComponents, [
            state
          ], "p0.registeredComponents")
        }
      }, 3, "LQ_2")
    ],
    [qwik._IMMUTABLE]: {
      apiHost: qwik._fnSignal((p0) => p0.apiHost, [
        props
      ], "p0.apiHost"),
      apiKey: qwik._fnSignal((p0) => p0.apiKey, [
        props
      ], "p0.apiKey"),
      builderContextSignal: qwik._fnSignal((p0) => p0.builderContextSignal, [
        state
      ], "p0.builderContextSignal"),
      canTrack: qwik._fnSignal((p0) => p0.canTrack, [
        props
      ], "p0.canTrack"),
      content: qwik._fnSignal((p0) => p0.content, [
        props
      ], "p0.content"),
      contentWrapper: qwik._fnSignal((p0) => p0.contentWrapper, [
        props
      ], "p0.contentWrapper"),
      contentWrapperProps: qwik._fnSignal((p0) => p0.contentWrapperProps, [
        props
      ], "p0.contentWrapperProps"),
      context: qwik._fnSignal((p0) => p0.context, [
        props
      ], "p0.context"),
      data: qwik._fnSignal((p0) => p0.data, [
        props
      ], "p0.data"),
      enrich: qwik._fnSignal((p0) => p0.enrich, [
        props
      ], "p0.enrich"),
      isNestedRender: qwik._fnSignal((p0) => p0.isNestedRender, [
        props
      ], "p0.isNestedRender"),
      locale: qwik._fnSignal((p0) => p0.locale, [
        props
      ], "p0.locale"),
      model: qwik._fnSignal((p0) => p0.model, [
        props
      ], "p0.model"),
      nonce: qwik._fnSignal((p0) => p0.nonce, [
        props
      ], "p0.nonce"),
      showContent: qwik._fnSignal((p0) => p0.showContent, [
        props
      ], "p0.showContent"),
      trustedHosts: qwik._fnSignal((p0) => p0.trustedHosts, [
        props
      ], "p0.trustedHosts")
    }
  }, 1, "LQ_3");
}, "ContentComponent_component_HIsczUcxjCE"));
exports.ContentComponent = ContentComponent;
exports.default = ContentComponent;
