"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const search = require("../../helpers/search/search.qwik.cjs");
const isBrowser = require("../is-browser.qwik.cjs");
const BUILDER_SEARCHPARAMS_PREFIX = "builder.";
const BUILDER_OPTIONS_PREFIX = "options.";
const getBuilderSearchParams = (_options) => {
  if (!_options)
    return {};
  const options = search.normalizeSearchParams(_options);
  const newOptions = {};
  Object.keys(options).forEach((key) => {
    if (key.startsWith(BUILDER_SEARCHPARAMS_PREFIX)) {
      const trimmedKey = key.replace(BUILDER_SEARCHPARAMS_PREFIX, "").replace(BUILDER_OPTIONS_PREFIX, "");
      newOptions[trimmedKey] = options[key];
    }
  });
  return newOptions;
};
const getBuilderSearchParamsFromWindow = () => {
  if (!isBrowser.isBrowser())
    return {};
  const searchParams = new URLSearchParams(window.location.search);
  return getBuilderSearchParams(searchParams);
};
exports.getBuilderSearchParams = getBuilderSearchParams;
exports.getBuilderSearchParamsFromWindow = getBuilderSearchParamsFromWindow;
