import { componentQrl, inlinedQrl, _jsxBranch, useStylesScopedQrl, useComputedQrl, useLexicalScope, _jsxC, Fragment, _jsxQ, _fnSignal, Slot } from "@builder.io/qwik";
import { getSrcSet } from "./image.helpers.qwik.mjs";
const Image = /* @__PURE__ */ componentQrl(/* @__PURE__ */ inlinedQrl((props) => {
  var _a, _b, _c, _d, _e, _f;
  _jsxBranch();
  useStylesScopedQrl(/* @__PURE__ */ inlinedQrl(STYLES, "Image_component_useStylesScoped_fBMYiVf9fuU"));
  const srcSetToUse = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    var _a2;
    const [props2] = useLexicalScope();
    const imageToUse = props2.image || props2.src;
    const url = imageToUse;
    if (!url || // We can auto add srcset for cdn.builder.io and shopify
    // images, otherwise you can supply this prop manually
    !(typeof url === "string" && (url.match(/builder\.io/) || url.match(/cdn\.shopify\.com/))))
      return props2.srcset;
    if (props2.noWebp)
      return void 0;
    if (props2.srcset && ((_a2 = props2.image) == null ? void 0 : _a2.includes("builder.io/api/v1/image"))) {
      if (!props2.srcset.includes(props2.image.split("?")[0])) {
        console.debug("Removed given srcset");
        return getSrcSet(url);
      }
    } else if (props2.image && !props2.srcset)
      return getSrcSet(url);
    return getSrcSet(url);
  }, "Image_component_srcSetToUse_useComputed_TZMibf9Gpvw", [
    props
  ]));
  const webpSrcSet = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    var _a2;
    const [props2, srcSetToUse2] = useLexicalScope();
    if (((_a2 = srcSetToUse2.value) == null ? void 0 : _a2.match(/builder\.io/)) && !props2.noWebp)
      return srcSetToUse2.value.replace(/\?/g, "?format=webp&");
    else
      return "";
  }, "Image_component_webpSrcSet_useComputed_01YCu72BBtA", [
    props,
    srcSetToUse
  ]));
  const aspectRatioCss = useComputedQrl(/* @__PURE__ */ inlinedQrl(() => {
    const [props2] = useLexicalScope();
    const aspectRatioStyles = {
      position: "absolute",
      height: "100%",
      width: "100%",
      left: "0px",
      top: "0px"
    };
    const out = props2.aspectRatio ? aspectRatioStyles : void 0;
    return out;
  }, "Image_component_aspectRatioCss_useComputed_yJ1jG0g5fbw", [
    props
  ]));
  return /* @__PURE__ */ _jsxC(Fragment, {
    children: [
      /* @__PURE__ */ _jsxQ("picture", null, null, [
        webpSrcSet.value ? /* @__PURE__ */ _jsxQ("source", null, {
          srcset: _fnSignal((p0) => p0.value, [
            webpSrcSet
          ], "p0.value"),
          type: "image/webp"
        }, null, 3, "0A_0") : null,
        /* @__PURE__ */ _jsxQ("img", null, {
          alt: _fnSignal((p0) => p0.altText, [
            props
          ], "p0.altText"),
          class: _fnSignal((p0) => "builder-image" + (p0.className ? " " + p0.className : "") + " img-Image", [
            props
          ], '"builder-image"+(p0.className?" "+p0.className:"")+" img-Image"'),
          fetchPriority: _fnSignal((p0) => p0.highPriority ? "high" : "auto", [
            props
          ], 'p0.highPriority?"high":"auto"'),
          loading: _fnSignal((p0) => p0.highPriority ? "eager" : "lazy", [
            props
          ], 'p0.highPriority?"eager":"lazy"'),
          role: _fnSignal((p0) => p0.altText ? void 0 : "presentation", [
            props
          ], 'p0.altText?undefined:"presentation"'),
          sizes: _fnSignal((p0) => p0.sizes, [
            props
          ], "p0.sizes"),
          src: _fnSignal((p0) => p0.image, [
            props
          ], "p0.image"),
          srcset: _fnSignal((p0) => p0.value, [
            srcSetToUse
          ], "p0.value"),
          style: _fnSignal((p0, p1) => ({
            objectPosition: p1.backgroundPosition || "center",
            objectFit: p1.backgroundSize || "cover",
            ...p0.value
          }), [
            aspectRatioCss,
            props
          ], '{objectPosition:p1.backgroundPosition||"center",objectFit:p1.backgroundSize||"cover",...p0.value}'),
          title: _fnSignal((p0) => p0.title, [
            props
          ], "p0.title")
        }, null, 3, null)
      ], 1, null),
      props.aspectRatio && !(((_b = (_a = props.builderBlock) == null ? void 0 : _a.children) == null ? void 0 : _b.length) && props.fitContent) ? /* @__PURE__ */ _jsxQ("div", null, {
        class: "builder-image-sizer div-Image",
        style: _fnSignal((p0) => ({
          paddingTop: p0.aspectRatio * 100 + "%"
        }), [
          props
        ], '{paddingTop:p0.aspectRatio*100+"%"}')
      }, null, 3, "0A_1") : null,
      ((_d = (_c = props.builderBlock) == null ? void 0 : _c.children) == null ? void 0 : _d.length) && props.fitContent ? /* @__PURE__ */ _jsxC(Slot, null, 3, "0A_2") : null,
      !props.fitContent && ((_f = (_e = props.builderBlock) == null ? void 0 : _e.children) == null ? void 0 : _f.length) ? /* @__PURE__ */ _jsxQ("div", null, {
        class: "div-Image-2"
      }, /* @__PURE__ */ _jsxC(Slot, null, 3, "0A_3"), 1, "0A_4") : null
    ]
  }, 1, "0A_5");
}, "Image_component_LRxDkFa1EfU"));
const STYLES = `
.img-Image {
  opacity: 1;
  transition: opacity 0.2s ease-in-out;
}
.div-Image {
  width: 100%;
  pointer-events: none;
  font-size: 0;
}
.div-Image-2 {
  display: flex;
  flex-direction: column;
  align-items: stretch;
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
}
`;
export {
  Image,
  STYLES,
  Image as default
};
