"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const target = require("../constants/target.qwik.cjs");
const css = require("../helpers/css.qwik.cjs");
const transformStyleProperty = require("./transform-style-property.qwik.cjs");
const getStyle = ({ block, context }) => {
  return mapStyleObjToStrIfNeeded(transformStyleProperty.transformStyleProperty({
    style: block.style || {},
    context,
    block
  }));
};
function mapStyleObjToStrIfNeeded(style) {
  switch (target.TARGET) {
    case "svelte":
    case "vue":
    case "solid":
    case "angular":
      return css.convertStyleMapToCSSArray(style).join(" ");
    case "qwik":
    case "reactNative":
    case "react":
    case "rsc":
      return style;
  }
}
exports.getStyle = getStyle;
exports.mapStyleObjToStrIfNeeded = mapStyleObjToStrIfNeeded;
